Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 1375)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 1557)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Enable monotone advection for scalars using monotonic limiter 
 ! 
 ! Former revisions:
@@ -194,6 +194,6 @@
        USE control_parameters,                                                 &
            ONLY:  cloud_physics, humidity, icloud_scheme, loop_optimization,   &
-                  passive_scalar, precipitation, ocean, ws_scheme_mom,         &
-                  ws_scheme_sca
+                  monotonic_adjustment, passive_scalar, precipitation, ocean,  &
+                  ws_scheme_mom, ws_scheme_sca
 
        USE indices,                                                            &
@@ -386,5 +386,6 @@
 
        USE control_parameters,                                                 &
-           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans 
+           ONLY:  intermediate_timestep_count, monotonic_adjustment, u_gtrans, &
+                  v_gtrans 
 
        USE grid_variables,                                                     &
@@ -421,4 +422,5 @@
        INTEGER(iwp) ::  k     !:
        INTEGER(iwp) ::  k_mm  !:
+       INTEGER(iwp) ::  k_mmm !:
        INTEGER(iwp) ::  k_pp  !:
        INTEGER(iwp) ::  k_ppp !:
@@ -428,4 +430,22 @@
        REAL(wp)     ::  div    !:
        REAL(wp)     ::  flux_d !:
+       REAL(wp)     ::  fd_1   !:
+       REAL(wp)     ::  fl_1   !:
+       REAL(wp)     ::  fn_1   !:
+       REAL(wp)     ::  fr_1   !:
+       REAL(wp)     ::  fs_1   !:
+       REAL(wp)     ::  ft_1   !:
+       REAL(wp)     ::  phi_d  !:
+       REAL(wp)     ::  phi_l  !:
+       REAL(wp)     ::  phi_n  !:
+       REAL(wp)     ::  phi_r  !:
+       REAL(wp)     ::  phi_s  !:
+       REAL(wp)     ::  phi_t  !:
+       REAL(wp)     ::  rd     !:
+       REAL(wp)     ::  rl     !:
+       REAL(wp)     ::  rn     !:
+       REAL(wp)     ::  rr     !:
+       REAL(wp)     ::  rs     !:
+       REAL(wp)     ::  rt     !:
        REAL(wp)     ::  u_comp !:
        REAL(wp)     ::  v_comp !:
@@ -697,4 +717,142 @@
                                          )
 !
+!--       Apply monotonic adjustment.
+          IF ( monotonic_adjustment )  THEN
+!
+!--          At first, calculate first order fluxes.
+             u_comp = u(k,j,i) - u_gtrans
+             fl_1   =  ( u_comp   * ( sk(k,j,i) + sk(k,j,i-1) )               &
+                   -ABS( u_comp ) * ( sk(k,j,i) - sk(k,j,i-1) )               &
+                       ) * adv_sca_1 
+
+             u_comp = u(k,j,i+1) - u_gtrans
+             fr_1   =  ( u_comp   * ( sk(k,j,i+1) + sk(k,j,i) )               &
+                   -ABS( u_comp ) * ( sk(k,j,i+1) - sk(k,j,i) )               &
+                       ) * adv_sca_1 
+
+             v_comp = v(k,j,i) - v_gtrans
+             fs_1   =  ( v_comp   * ( sk(k,j,i) + sk(k,j-1,i) )               &
+                   -ABS( v_comp ) * ( sk(k,j,i) - sk(k,j-1,i) )               &
+                       ) * adv_sca_1 
+
+             v_comp = v(k,j+1,i) - v_gtrans
+             fn_1   =  ( v_comp   * ( sk(k,j+1,i) + sk(k,j,i) )               &
+                   -ABS( v_comp ) * ( sk(k,j+1,i) - sk(k,j,i) )               &
+                       ) * adv_sca_1 
+
+             fd_1   =  ( w(k-1,j,i)   * ( sk(k,j,i) + sk(k-1,j,i) )           &
+                   -ABS( w(k-1,j,i) ) * ( sk(k,j,i) - sk(k-1,j,i) )           &
+                       ) * adv_sca_1 
+
+             ft_1   =  ( w(k,j,i)   * ( sk(k+1,j,i) + sk(k,j,i) )             &
+                   -ABS( w(k,j,i) ) * ( sk(k+1,j,i) - sk(k,j,i) )             &
+                      ) * adv_sca_1 
+!
+!--          Calculate ratio of upwind gradients. Note, Min/Max is just to 
+!--          avoid if statements.
+             rl     = ( MAX( 0.0, u(k,j,i) - u_gtrans ) *                     & 
+                           ABS( ( sk(k,j,i-1) - sk(k,j,i-2)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j,i-1) + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, u(k,j,i) - u_gtrans ) *                     &
+                           ABS( ( sk(k,j,i)   - sk(k,j,i+1)            ) /    &
+                                ( sk(k,j,i-1) - sk(k,j,i)   + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( u(k,j,i) - u_gtrans + 1E-20_wp )
+
+             rr     = ( MAX( 0.0, u(k,j,i+1) - u_gtrans ) *                   & 
+                           ABS( ( sk(k,j,i)   - sk(k,j,i-1)            ) /    &
+                                ( sk(k,j,i+1) - sk(k,j,i)   + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, u(k,j,i+1) - u_gtrans ) *                   &
+                           ABS( ( sk(k,j,i+1) - sk(k,j,i+2)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j,i+1) + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( u(k,j,i+1) - u_gtrans + 1E-20_wp )
+
+             rs     = ( MAX( 0.0, v(k,j,i) - v_gtrans ) *                     & 
+                           ABS( ( sk(k,j-1,i) - sk(k,j-2,i)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j-1,i) + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, v(k,j,i) - v_gtrans ) *                     &
+                           ABS( ( sk(k,j,i)   - sk(k,j+1,i)            ) /    &
+                                ( sk(k,j-1,i) - sk(k,j,i)   + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( v(k,j,i) - v_gtrans + 1E-20_wp )
+
+             rn     = ( MAX( 0.0, v(k,j+1,i) - v_gtrans ) *                   & 
+                           ABS( ( sk(k,j,i)   - sk(k,j-1,i)            ) /    &
+                                ( sk(k,j+1,i) - sk(k,j,i)   + 1E-20_wp )      &
+                              ) +                                             & 
+                       MIN( 0.0, v(k,j+1,i) - v_gtrans ) *                    &
+                           ABS( ( sk(k,j+1,i) - sk(k,j+2,i)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j+1,i) + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( v(k,j+1,i) - v_gtrans + 1E-20_wp )     
+!   
+!--          Reuse k_mm and compute k_mmm for the vertical gradient ratios. 
+!--          Note, for vertical advection below the third grid point above 
+!--          surface ( or below the model top) rd and rt are set to 0, i.e. 
+!--          use of first order scheme is enforced.
+             k_mmm  = k - 3 * ibit8
+
+             rd     = ( MAX( 0.0, w(k-1,j,i) ) *                              & 
+                           ABS( ( sk(k_mm,j,i) - sk(k_mmm,j,i)           ) /  &
+                                ( sk(k-1,j,i)  - sk(k_mm,j,i) + 1E-20_wp )    &
+                              ) +                                             & 
+                        MIN( 0.0, w(k-1,j,i) ) *                              &
+                           ABS( ( sk(k-1,j,i) - sk(k,j,i)            ) /      &
+                                ( sk(k_mm,j,i) - sk(k-1,j,i)   + 1E-20_wp )   &
+                              )                                               &
+                      ) * ibit8 / ABS( w(k-1,j,i) + 1E-20_wp ) 
+ 
+             rt     = ( MAX( 0.0, w(k,j,i) ) *                                & 
+                           ABS( ( sk(k,j,i)   - sk(k-1,j,i)            ) /    &
+                                ( sk(k+1,j,i) - sk(k,j,i)   + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, w(k,j,i) ) *                                &
+                           ABS( ( sk(k+1,j,i) - sk(k_pp,j,i)           ) /    &
+                                ( sk(k,j,i)   - sk(k+1,j,i) + 1E-20_wp )      &
+                              )                                               &
+                      ) * ibit8 / ABS( w(k,j,i) + 1E-20_wp )
+!
+!--           Calculate empirical limiter function (van Albada2 limiter).
+              phi_l = MIN( 1.0_wp, ( 2.0_wp * rl ) /                          &
+                                         ( rl**2 + 1.0_wp ) ) 
+              phi_r = MIN( 1.0_wp, ( 2.0_wp * rr ) /                          &
+                                         ( rr**2 + 1.0_wp ) ) 
+              phi_s = MIN( 1.0_wp, ( 2.0_wp * rs ) /                          &
+                                         ( rs**2 + 1.0_wp ) ) 
+              phi_n = MIN( 1.0_wp, ( 2.0_wp * rn ) /                          &
+                                         ( rn**2 + 1.0_wp ) ) 
+              phi_d = MIN( 1.0_wp, ( 2.0_wp * rd ) /                          &
+                                         ( rd**2 + 1.0_wp ) ) 
+              phi_t = MIN( 1.0_wp, ( 2.0_wp * rt ) /                          &
+                                         ( rt**2 + 1.0_wp ) ) 
+!
+!--           Calculate the resulting monotone flux. 
+              swap_flux_x_local(k,j,tn) = fl_1 - phi_l *                      &
+                                        ( fl_1 - swap_flux_x_local(k,j,tn)  )
+              flux_r(k)                 = fr_1 - phi_r *                      &
+                                        ( fr_1 - flux_r(k)                  )
+              swap_flux_y_local(k,tn)   = fs_1 - phi_s *                      &
+                                        ( fs_1 - swap_flux_y_local(k,tn)    )
+              flux_n(k)                 = fn_1 - phi_n *                      &
+                                        ( fn_1 - flux_n(k)                  )
+              flux_d                    = fd_1  !- phi_d *                      &
+!                                         ( fd_1 - flux_d                     )
+              flux_t(k)                 = ft_1 !- phi_t *                      &
+!                                         ( ft_1 - flux_t(k)                  )
+!
+!--          Moreover, modify dissipation flux according to the limiter. 
+             swap_diss_x_local(k,j,tn) = swap_diss_x_local(k,j,tn) * phi_l
+             diss_r(k)                 = diss_r(k)                 * phi_r
+             swap_diss_y_local(k,tn)   = swap_diss_y_local(k,tn)   * phi_s
+             diss_n(k)                 = diss_n(k)                 * phi_n
+             diss_d                    = 0.0 !diss_d                    * phi_d
+             diss_t(k)                 = 0.0 !diss_t(k)                 * phi_t
+
+          ENDIF
+!
 !--       Calculate the divergence of the velocity field. A respective
 !--       correction is needed to overcome numerical instabilities caused
@@ -756,5 +914,4 @@
           k_pp  = k + 2 * ( 1 - ibit6  )
           k_mm  = k - 2 * ibit8
-
 
           flux_t(k) = w(k,j,i) * (                                            &
@@ -786,4 +943,144 @@
                              ( sk(k_ppp,j,i) - sk(k_mm,j,i) )                 &
                                          )
+
+
+!
+!--       Apply monotonic adjustment.
+          IF ( monotonic_adjustment )  THEN
+!
+!--          At first, calculate first order fluxes.
+             u_comp = u(k,j,i) - u_gtrans
+             fl_1   =  ( u_comp   * ( sk(k,j,i) + sk(k,j,i-1) )               &
+                   -ABS( u_comp ) * ( sk(k,j,i) - sk(k,j,i-1) )               &
+                       ) * adv_sca_1 
+
+             u_comp = u(k,j,i+1) - u_gtrans
+             fr_1   =  ( u_comp   * ( sk(k,j,i+1) + sk(k,j,i) )               &
+                   -ABS( u_comp ) * ( sk(k,j,i+1) - sk(k,j,i) )               &
+                       ) * adv_sca_1 
+
+             v_comp = v(k,j,i) - v_gtrans
+             fs_1   =  ( v_comp   * ( sk(k,j,i) + sk(k,j-1,i) )               &
+                   -ABS( v_comp ) * ( sk(k,j,i) - sk(k,j-1,i) )               &
+                       ) * adv_sca_1 
+
+             v_comp = v(k,j+1,i) - v_gtrans
+             fn_1   =  ( v_comp   * ( sk(k,j+1,i) + sk(k,j,i) )               &
+                   -ABS( v_comp ) * ( sk(k,j+1,i) - sk(k,j,i) )               &
+                       ) * adv_sca_1 
+
+             fd_1   =  ( w(k-1,j,i)   * ( sk(k,j,i) + sk(k-1,j,i) )           &
+                   -ABS( w(k-1,j,i) ) * ( sk(k,j,i) - sk(k-1,j,i) )           &
+                       ) * adv_sca_1 
+
+             ft_1   =  ( w(k,j,i)   * ( sk(k+1,j,i) + sk(k,j,i) )             &
+                   -ABS( w(k,j,i) ) * ( sk(k+1,j,i) - sk(k,j,i) )             &
+                       ) * adv_sca_1 
+!
+!--          Calculate ratio of upwind gradients. Note, Min/Max is just to 
+!--          avoid if statements. 
+             rl     = ( MAX( 0.0, u(k,j,i) - u_gtrans ) *                     & 
+                           ABS( ( sk(k,j,i-1) - sk(k,j,i-2)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j,i-1) + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, u(k,j,i) - u_gtrans ) *                     &
+                           ABS( ( sk(k,j,i)   - sk(k,j,i+1)            ) /    &
+                                ( sk(k,j,i-1) - sk(k,j,i)   + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( u(k,j,i) - u_gtrans + 1E-20_wp )
+
+             rr     = ( MAX( 0.0, u(k,j,i+1) - u_gtrans ) *                   & 
+                           ABS( ( sk(k,j,i)   - sk(k,j,i-1)            ) /    &
+                                ( sk(k,j,i+1) - sk(k,j,i)   + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, u(k,j,i+1) - u_gtrans ) *                   &
+                           ABS( ( sk(k,j,i+1) - sk(k,j,i+2)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j,i+1) + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( u(k,j,i+1) - u_gtrans + 1E-20_wp )
+
+             rs     = ( MAX( 0.0, v(k,j,i) - v_gtrans ) *                     & 
+                           ABS( ( sk(k,j-1,i) - sk(k,j-2,i)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j-1,i) + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, v(k,j,i) - v_gtrans ) *                     &
+                           ABS( ( sk(k,j,i)   - sk(k,j+1,i)            ) /    &
+                                ( sk(k,j-1,i) - sk(k,j,i)   + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( v(k,j,i) - v_gtrans + 1E-20_wp )
+
+             rn     = ( MAX( 0.0, v(k,j+1,i) - v_gtrans ) *                   & 
+                           ABS( ( sk(k,j,i)   - sk(k,j-1,i)            ) /    &
+                                ( sk(k,j+1,i) - sk(k,j,i)   + 1E-20_wp )      &
+                              ) +                                             & 
+                       MIN( 0.0, v(k,j+1,i) - v_gtrans ) *                    &
+                           ABS( ( sk(k,j+1,i) - sk(k,j+2,i)            ) /    &
+                                ( sk(k,j,i)   - sk(k,j+1,i) + 1E-20_wp )      &
+                              )                                               &
+                      ) / ABS( v(k,j+1,i) - v_gtrans + 1E-20_wp )     
+!
+!--          Reuse k_mm and compute k_mmm for the vertical gradient ratios. 
+!--          Note, for vertical advection below the third grid point above 
+!--          surface ( or below the model top) rd and rt are set to 0, i.e. 
+!--          use of first order scheme is enforced.
+             k_mmm  = k - 3 * ibit8
+
+             rd     = ( MAX( 0.0, w(k-1,j,i) ) *                              & 
+                           ABS( ( sk(k_mm,j,i) - sk(k_mmm,j,i)           ) /  &
+                                ( sk(k-1,j,i)  - sk(k_mm,j,i) + 1E-20_wp )    &
+                              ) +                                             & 
+                        MIN( 0.0, w(k-1,j,i) ) *                              &
+                           ABS( ( sk(k-1,j,i) - sk(k,j,i)            ) /      &
+                                ( sk(k_mm,j,i) - sk(k-1,j,i)   + 1E-20_wp )   &
+                              )                                               &
+                      ) * ibit8 / ABS( w(k-1,j,i) + 1E-20_wp ) 
+ 
+             rt     = ( MAX( 0.0, w(k,j,i) ) *                                & 
+                           ABS( ( sk(k,j,i)   - sk(k-1,j,i)            ) /    &
+                                ( sk(k+1,j,i) - sk(k,j,i)   + 1E-20_wp )      &
+                              ) +                                             & 
+                        MIN( 0.0, w(k,j,i) ) *                                &
+                           ABS( ( sk(k+1,j,i) - sk(k_pp,j,i)           ) /    &
+                                ( sk(k,j,i)   - sk(k+1,j,i) + 1E-20_wp )      &
+                              )                                               &
+                      ) * ibit8 / ABS( w(k,j,i) + 1E-20_wp ) 
+!
+!--           Calculate empirical limiter function (van Albada2 limiter).
+              phi_l = MIN( 1.0_wp, ( 2.0_wp * rl ) /                          &
+                                         ( rl**2 + 1.0_wp ) ) 
+              phi_r = MIN( 1.0_wp, ( 2.0_wp * rr ) /                          &
+                                         ( rr**2 + 1.0_wp ) ) 
+              phi_s = MIN( 1.0_wp, ( 2.0_wp * rs ) /                          &
+                                         ( rs**2 + 1.0_wp ) ) 
+              phi_n = MIN( 1.0_wp, ( 2.0_wp * rn ) /                          &
+                                         ( rn**2 + 1.0_wp ) ) 
+              phi_d = MIN( 1.0_wp, ( 2.0_wp * rd ) /                          &
+                                         ( rd**2 + 1.0_wp ) ) 
+              phi_t = MIN( 1.0_wp, ( 2.0_wp * rt ) /                          &
+                                         ( rt**2 + 1.0_wp ) ) 
+!
+!--           Calculate the resulting monotone flux. 
+              swap_flux_x_local(k,j,tn) = fl_1 - phi_l *                      &
+                                        ( fl_1 - swap_flux_x_local(k,j,tn)  )
+              flux_r(k)                 = fr_1 - phi_r *                      &
+                                        ( fr_1 - flux_r(k)                  )
+              swap_flux_y_local(k,tn)   = fs_1 - phi_s *                      &
+                                        ( fs_1 - swap_flux_y_local(k,tn)    )
+              flux_n(k)                 = fn_1 - phi_n *                      &
+                                        ( fn_1 - flux_n(k)                  )
+              flux_d                    = fd_1 - phi_d *                      &
+                                        ( fd_1 - flux_d                     )
+              flux_t(k)                 = ft_1 - phi_t *                      &
+                                        ( ft_1 - flux_t(k)                  )
+!
+!--          Moreover, modify dissipation flux according to the limiter. 
+             swap_diss_x_local(k,j,tn) = swap_diss_x_local(k,j,tn) * phi_l
+             diss_r(k)                 = diss_r(k)                 * phi_r
+             swap_diss_y_local(k,tn)   = swap_diss_y_local(k,tn)   * phi_s
+             diss_n(k)                 = diss_n(k)                 * phi_n
+             diss_d                    = diss_d                    * phi_d
+             diss_t(k)                 = diss_t(k)                 * phi_t
+
+          ENDIF
 !
 !--       Calculate the divergence of the velocity field. A respective
@@ -803,4 +1100,5 @@
                                       ) + sk(k,j,i) * div
 
+
           swap_flux_y_local(k,tn)   = flux_n(k)
           swap_diss_y_local(k,tn)   = diss_n(k)
@@ -813,48 +1111,52 @@
 
 !
-!--    Evaluation of statistics
-       SELECT CASE ( sk_char )
-
-          CASE ( 'pt' )
-
-             DO  k = nzb, nzt
-                sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn) +               &
-                                       ( flux_t(k) + diss_t(k) )              &
-                                 * weight_substep(intermediate_timestep_count)
+!--    Evaluation of statistics. Please note, in case of using monotone limiter
+!--    vertical fluxes will be not calculated by the advective fluxes.
+       IF ( .NOT. monotonic_adjustment )  THEN
+
+          SELECT CASE ( sk_char )
+
+             CASE ( 'pt' )
+
+                DO  k = nzb, nzt
+                   sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn) +            &
+                                          ( flux_t(k) + diss_t(k) )           &
+                                  * weight_substep(intermediate_timestep_count)
              ENDDO
              
-          CASE ( 'sa' )
-
-             DO  k = nzb, nzt
-                sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn) +               &
-                                       ( flux_t(k) + diss_t(k) )              &
-                                 * weight_substep(intermediate_timestep_count)
-             ENDDO
+             CASE ( 'sa' )
+
+                DO  k = nzb, nzt
+                   sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn) +            &
+                                          ( flux_t(k) + diss_t(k) )           &
+                                  * weight_substep(intermediate_timestep_count)
+                ENDDO
              
-          CASE ( 'q' )
-
-             DO  k = nzb, nzt
-                sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn) +                &
-                                      ( flux_t(k) + diss_t(k) )               &
-                                 * weight_substep(intermediate_timestep_count)
-             ENDDO
-
-          CASE ( 'qr' )
-
-             DO  k = nzb, nzt
-                sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn) +              &
-                                      ( flux_t(k) + diss_t(k) )               &
-                                 * weight_substep(intermediate_timestep_count)
-             ENDDO
-
-          CASE ( 'nr' )
-
-             DO  k = nzb, nzt
-                sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn) +              &
-                                      ( flux_t(k) + diss_t(k) )               &
-                                 * weight_substep(intermediate_timestep_count)
-             ENDDO
-
-         END SELECT
+             CASE ( 'q' )
+
+                DO  k = nzb, nzt
+                   sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn) +             &
+                                         ( flux_t(k) + diss_t(k) )            &
+                                  * weight_substep(intermediate_timestep_count)
+                ENDDO
+
+             CASE ( 'qr' )
+
+                DO  k = nzb, nzt
+                   sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn) +           &
+                                         ( flux_t(k) + diss_t(k) )            &
+                                  * weight_substep(intermediate_timestep_count)
+                ENDDO
+
+             CASE ( 'nr' )
+
+                DO  k = nzb, nzt
+                   sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn) +           &
+                                         ( flux_t(k) + diss_t(k) )            &
+                                  * weight_substep(intermediate_timestep_count)
+                ENDDO
+
+            END SELECT
+         ENDIF
 
     END SUBROUTINE advec_s_ws_ij
@@ -2228,5 +2530,6 @@
 
        USE control_parameters,                                                &
-           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans 
+           ONLY:  intermediate_timestep_count, monotonic_adjustment, u_gtrans,&
+                  v_gtrans 
 
        USE grid_variables,                                                    &
